'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _app = require('firebase/app');

var _app2 = _interopRequireDefault(_app);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _objectWithoutProperties(obj, keys) { var target = {}; for (var i in obj) { if (keys.indexOf(i) >= 0) continue; if (!Object.prototype.hasOwnProperty.call(obj, i)) continue; target[i] = obj[i]; } return target; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var getSubscriptions = function getSubscriptions(props) {
  if (typeof props.query === 'string') {
    return _defineProperty({}, props.query, { path: props.query });
  }
  if (!props.query) {
    return {};
  }

  return (0, _utils.mapValues)(props.query, function (value) {
    return typeof value === 'string' ? { path: value } : value;
  });
};

var Firebase = function (_React$Component) {
  _inherits(Firebase, _React$Component);

  function Firebase() {
    var _ref2;

    var _temp, _this, _ret;

    _classCallCheck(this, Firebase);

    for (var _len = arguments.length, args = Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    return _ret = (_temp = (_this = _possibleConstructorReturn(this, (_ref2 = Firebase.__proto__ || Object.getPrototypeOf(Firebase)).call.apply(_ref2, [this].concat(args))), _this), _this.state = {
      subscriptionsState: {},
      connected: false
    }, _temp), _possibleConstructorReturn(_this, _ret);
  }

  _createClass(Firebase, [{
    key: 'componentDidMount',
    value: function componentDidMount() {
      this.mounted = true;
      this.subscribe(getSubscriptions(this.props));
    }
  }, {
    key: 'componentWillReceiveProps',
    value: function componentWillReceiveProps(nextProps, nextContext) {
      var ref = this.getFirebaseRef(nextProps, nextContext);
      var subscriptions = getSubscriptions(this.props);
      var nextSubscriptions = getSubscriptions(nextProps);
      var addedSubscriptions = (0, _utils.pickBy)(nextSubscriptions, function (path, key) {
        return !subscriptions[key];
      });
      var removedSubscriptions = (0, _utils.pickBy)(subscriptions, function (path, key) {
        return !nextSubscriptions[key];
      });
      var changedSubscriptions = (0, _utils.pickBy)(nextSubscriptions, function (subscription, key) {
        return subscriptions[key] && subscriptions[key].path !== subscription.path;
      });

      this.unsubscribe(_extends({}, removedSubscriptions, changedSubscriptions));
      this.subscribe(_extends({}, addedSubscriptions, changedSubscriptions), ref);
    }
  }, {
    key: 'componentWillUnmount',
    value: function componentWillUnmount() {
      this.mounted = false;

      if (this.listeners) {
        this.unsubscribe(this.listeners);
      }
    }
  }, {
    key: 'getFirebaseRef',
    value: function getFirebaseRef(props, context) {
      var _this2 = this;

      return function (path) {
        return _this2.getFirebaseApp(props, context).database().ref(path);
      };
    }
  }, {
    key: 'getFirebaseApp',
    value: function getFirebaseApp() {
      var props = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : this.props;
      var context = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.context;

      return props.firebaseApp || context.firebaseApp || _app2.default.app();
    }
  }, {
    key: 'getFirebaseProps',
    value: function getFirebaseProps() {
      if (typeof this.props.query === 'string') {
        return this.state.subscriptionsState[this.props.query];
      }

      return this.state.subscriptionsState;
    }
  }, {
    key: 'subscribe',
    value: function subscribe(subscriptions) {
      var _this3 = this;

      var ref = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : this.getFirebaseRef();

      if (Object.keys(subscriptions).length < 1) {
        return;
      }

      var nextListeners = (0, _utils.mapValues)(subscriptions, function (_ref3, key) {
        var path = _ref3.path,
            query = _objectWithoutProperties(_ref3, ['path']);

        var containsOrderBy = Object.keys(query).some(function (queryKey) {
          return queryKey.startsWith('orderBy');
        });
        var subscriptionRef = (0, _utils.createQueryRef)(ref(path), query);
        var update = function update(snapshot) {
          if (_this3.mounted) {
            var value = containsOrderBy ? (0, _utils.mapSnapshotToValue)(snapshot) : snapshot.val();

            _this3.setState(function (prevState) {
              return {
                connected: true,
                subscriptionsState: _extends({}, prevState.subscriptionsState, _defineProperty({}, key, value))
              };
            });
          }
        };

        subscriptionRef.on('value', update);

        return {
          path: path,
          unsubscribe: function unsubscribe() {
            return subscriptionRef.off('value', update);
          }
        };
      });

      this.listeners = _extends({}, this.listeners, nextListeners);
    }
  }, {
    key: 'unsubscribe',
    value: function unsubscribe(subscriptions) {
      var _this4 = this;

      if (Object.keys(subscriptions).length < 1) {
        return;
      }

      var nextListeners = _extends({}, this.listeners);
      var nextSubscriptionsState = _extends({}, this.state.subscriptionsState);

      Object.keys(subscriptions).forEach(function (key) {
        var subscription = _this4.listeners[key];
        subscription.unsubscribe();

        delete nextListeners[key];
        delete nextSubscriptionsState[key];
      });

      this.listeners = nextListeners;
      this.setState({ subscriptionsState: nextSubscriptionsState });
    }
  }, {
    key: 'render',
    value: function render() {
      if (this.state.connected && this.props.render) {
        return this.props.render(this.getFirebaseProps(), this.getFirebaseRef(), this.getFirebaseApp());
      } else if (this.props.children) {
        return this.props.children(this.getFirebaseProps(), this.getFirebaseRef(), this.getFirebaseApp());
      }

      return null;
    }
  }]);

  return Firebase;
}(_react2.default.Component);

Firebase.propTypes = {
  render: _propTypes2.default.func,
  children: _propTypes2.default.func,
  query: _propTypes2.default.oneOfType([_propTypes2.default.object, _propTypes2.default.string, _propTypes2.default.func]),
  firebaseApp: _propTypes2.default.instanceOf(_app2.default.app.App) // eslint-disable-line react/no-unused-prop-types
};
Firebase.contextTypes = {
  firebaseApp: _propTypes2.default.instanceOf(_app2.default.app.App)
};
exports.default = Firebase;
module.exports = exports['default'];