'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _app = require('firebase/app');

var _app2 = _interopRequireDefault(_app);

var _Firebase = require('./Firebase');

var _Firebase2 = _interopRequireDefault(_Firebase);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultMapFirebaseToProps = function defaultMapFirebaseToProps(props, ref, firebaseApp) {
  return {
    firebaseApp: firebaseApp
  };
};

exports.default = function () {
  var mapFirebaseToProps = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : defaultMapFirebaseToProps;
  return function (WrappedComponent) {
    var FirebaseConnect = function FirebaseConnect(props) {
      return _react2.default.createElement(_Firebase2.default, {
        firebaseApp: props.firebaseApp,
        query: mapFirebaseToProps,
        render: function render(firebaseProps) {
          return _react2.default.createElement(WrappedComponent, _extends({}, firebaseProps, props));
        }
      });
    };

    FirebaseConnect.WrappedComponent = WrappedComponent;
    FirebaseConnect.displayName = 'FirebaseConnect(' + (0, _utils.getDisplayName)(WrappedComponent) + ')';
    FirebaseConnect.propTypes = {
      firebaseApp: _propTypes2.default.instanceOf(_app2.default.app.App)
    };

    return FirebaseConnect;
  };
};

module.exports = exports['default'];