'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _app = require('firebase/app');

var _app2 = _interopRequireDefault(_app);

var _Firebase = require('./Firebase');

var _Firebase2 = _interopRequireDefault(_Firebase);

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (WrappedComponent) {
  var WithFirebase = function WithFirebase(props) {
    return _react2.default.createElement(
      _Firebase2.default,
      { firebaseApp: props.firebaseApp },
      function (firebaseProps, firebaseRef, firebaseApp) {
        return _react2.default.createElement(WrappedComponent, _extends({ firebaseApp: firebaseApp, firebaseRef: firebaseRef }, props));
      }
    );
  };

  WithFirebase.WrappedComponent = WrappedComponent;
  WithFirebase.displayName = 'WithFirebase(' + (0, _utils.getDisplayName)(WrappedComponent) + ')';
  WithFirebase.propTypes = {
    firebaseApp: _propTypes2.default.instanceOf(_app2.default.app.App)
  };

  return WithFirebase;
};

module.exports = exports['default'];